<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AuthFastLeaderElection.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">AuthFastLeaderElection.java</span></div><h1>AuthFastLeaderElection.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetSocketAddress;
import java.net.SocketException;
import java.nio.ByteBuffer;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.Semaphore;

import java.util.concurrent.TimeUnit;
import java.util.Random;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.zookeeper.jmx.MBeanRegistry;
import org.apache.zookeeper.server.ZooKeeperThread;
import org.apache.zookeeper.server.quorum.Election;
import org.apache.zookeeper.server.quorum.Vote;
import org.apache.zookeeper.server.quorum.QuorumPeer.QuorumServer;
import org.apache.zookeeper.server.quorum.QuorumPeer.ServerState;

/**
 * @deprecated This class has been deprecated as of release 3.4.0. 
 */
@Deprecated
public class AuthFastLeaderElection implements Election {
<span class="nc" id="L54">    private static final Logger LOG = LoggerFactory.getLogger(AuthFastLeaderElection.class);</span>

    /* Sequence numbers for messages */
<span class="nc" id="L57">    static int sequencer = 0;</span>
<span class="nc" id="L58">    static int maxTag = 0;</span>

    /*
     * Determine how much time a process has to wait once it believes that it
     * has reached the end of leader election.
     */
<span class="nc" id="L64">    static int finalizeWait = 100;</span>

    /*
     * Challenge counter to avoid replay attacks
     */

<span class="nc" id="L70">    static int challengeCounter = 0;</span>

    /*
     * Flag to determine whether to authenticate or not
     */

<span class="nc" id="L76">    private boolean authEnabled = false;</span>

<span class="nc" id="L78">    static public class Notification {</span>
        /*
         * Proposed leader
         */
        long leader;

        /*
         * zxid of the proposed leader
         */
        long zxid;

        /*
         * Epoch
         */
        long epoch;

        /*
         * current state of sender
         */
        QuorumPeer.ServerState state;

        /*
         * Address of the sender
         */
        InetSocketAddress addr;
    }

    /*
     * Messages to send, both Notifications and Acks
     */
    static public class ToSend {
<span class="nc" id="L109">        static enum mType {</span>
<span class="nc" id="L110">            crequest, challenge, notification, ack</span>
        }

        ToSend(mType type, long tag, long leader, long zxid, long epoch,
<span class="nc" id="L114">                ServerState state, InetSocketAddress addr) {</span>

<span class="nc bnc" id="L116" title="All 5 branches missed.">            switch (type) {</span>
            case crequest:
<span class="nc" id="L118">                this.type = 0;</span>
<span class="nc" id="L119">                this.tag = tag;</span>
<span class="nc" id="L120">                this.leader = leader;</span>
<span class="nc" id="L121">                this.zxid = zxid;</span>
<span class="nc" id="L122">                this.epoch = epoch;</span>
<span class="nc" id="L123">                this.state = state;</span>
<span class="nc" id="L124">                this.addr = addr;</span>

<span class="nc" id="L126">                break;</span>
            case challenge:
<span class="nc" id="L128">                this.type = 1;</span>
<span class="nc" id="L129">                this.tag = tag;</span>
<span class="nc" id="L130">                this.leader = leader;</span>
<span class="nc" id="L131">                this.zxid = zxid;</span>
<span class="nc" id="L132">                this.epoch = epoch;</span>
<span class="nc" id="L133">                this.state = state;</span>
<span class="nc" id="L134">                this.addr = addr;</span>

<span class="nc" id="L136">                break;</span>
            case notification:
<span class="nc" id="L138">                this.type = 2;</span>
<span class="nc" id="L139">                this.leader = leader;</span>
<span class="nc" id="L140">                this.zxid = zxid;</span>
<span class="nc" id="L141">                this.epoch = epoch;</span>
<span class="nc" id="L142">                this.state = QuorumPeer.ServerState.LOOKING;</span>
<span class="nc" id="L143">                this.tag = tag;</span>
<span class="nc" id="L144">                this.addr = addr;</span>

<span class="nc" id="L146">                break;</span>
            case ack:
<span class="nc" id="L148">                this.type = 3;</span>
<span class="nc" id="L149">                this.tag = tag;</span>
<span class="nc" id="L150">                this.leader = leader;</span>
<span class="nc" id="L151">                this.zxid = zxid;</span>
<span class="nc" id="L152">                this.epoch = epoch;</span>
<span class="nc" id="L153">                this.state = state;</span>
<span class="nc" id="L154">                this.addr = addr;</span>

<span class="nc" id="L156">                break;</span>
            default:
                break;
            }
<span class="nc" id="L160">        }</span>

        /*
         * Message type: 0 notification, 1 acknowledgement
         */
        int type;

        /*
         * Proposed leader in the case of notification
         */
        long leader;

        /*
         * id contains the tag for acks, and zxid for notifications
         */
        long zxid;

        /*
         * Epoch
         */
        long epoch;

        /*
         * Current state;
         */
        QuorumPeer.ServerState state;

        /*
         * Message tag
         */
        long tag;

        InetSocketAddress addr;
    }

    LinkedBlockingQueue&lt;ToSend&gt; sendqueue;

    LinkedBlockingQueue&lt;Notification&gt; recvqueue;

    private class Messenger {

        final DatagramSocket mySocket;
        long lastProposedLeader;
        long lastProposedZxid;
        long lastEpoch;
        final Set&lt;Long&gt; ackset;
        final ConcurrentHashMap&lt;Long, Long&gt; challengeMap;
        final ConcurrentHashMap&lt;Long, Semaphore&gt; challengeMutex;
        final ConcurrentHashMap&lt;Long, Semaphore&gt; ackMutex;
        final ConcurrentHashMap&lt;InetSocketAddress, ConcurrentHashMap&lt;Long, Long&gt;&gt; addrChallengeMap;

        class WorkerReceiver implements Runnable {

            DatagramSocket mySocket;
            Messenger myMsg;

<span class="nc" id="L216">            WorkerReceiver(DatagramSocket s, Messenger msg) {</span>
<span class="nc" id="L217">                mySocket = s;</span>
<span class="nc" id="L218">                myMsg = msg;</span>
<span class="nc" id="L219">            }</span>

            boolean saveChallenge(long tag, long challenge) {
<span class="nc" id="L222">                Semaphore s = challengeMutex.get(tag);</span>
<span class="nc bnc" id="L223" title="All 2 branches missed.">                if (s != null) {</span>
<span class="nc" id="L224">                        synchronized (Messenger.this) {</span>
<span class="nc" id="L225">                            challengeMap.put(tag, challenge);</span>
<span class="nc" id="L226">                            challengeMutex.remove(tag);</span>
<span class="nc" id="L227">                        }</span>

                
<span class="nc" id="L230">                        s.release();</span>
                } else {
<span class="nc" id="L232">                    LOG.error(&quot;No challenge mutex object&quot;);</span>
                }
                

<span class="nc" id="L236">                return true;</span>
            }

            public void run() {
<span class="nc" id="L240">                byte responseBytes[] = new byte[48];</span>
<span class="nc" id="L241">                ByteBuffer responseBuffer = ByteBuffer.wrap(responseBytes);</span>
<span class="nc" id="L242">                DatagramPacket responsePacket = new DatagramPacket(</span>
                        responseBytes, responseBytes.length);
                while (true) {
                    // Sleeps on receive
                    try {
<span class="nc" id="L247">                        responseBuffer.clear();</span>
<span class="nc" id="L248">                        mySocket.receive(responsePacket);</span>
<span class="nc" id="L249">                    } catch (IOException e) {</span>
<span class="nc" id="L250">                        LOG.warn(&quot;Ignoring exception receiving&quot;, e);</span>
<span class="nc" id="L251">                    }</span>
                    // Receive new message
<span class="nc bnc" id="L253" title="All 2 branches missed.">                    if (responsePacket.getLength() != responseBytes.length) {</span>
<span class="nc" id="L254">                        LOG.warn(&quot;Got a short response: &quot;</span>
<span class="nc" id="L255">                                + responsePacket.getLength() + &quot; &quot;</span>
<span class="nc" id="L256">                                + responsePacket.toString());</span>
<span class="nc" id="L257">                        continue;</span>
                    }
<span class="nc" id="L259">                    responseBuffer.clear();</span>
<span class="nc" id="L260">                    int type = responseBuffer.getInt();</span>
<span class="nc bnc" id="L261" title="All 4 branches missed.">                    if ((type &gt; 3) || (type &lt; 0)) {</span>
<span class="nc" id="L262">                        LOG.warn(&quot;Got bad Msg type: &quot; + type);</span>
<span class="nc" id="L263">                        continue;</span>
                    }
<span class="nc" id="L265">                    long tag = responseBuffer.getLong();</span>

<span class="nc" id="L267">                    QuorumPeer.ServerState ackstate = QuorumPeer.ServerState.LOOKING;</span>
<span class="nc bnc" id="L268" title="All 4 branches missed.">                    switch (responseBuffer.getInt()) {</span>
                    case 0:
<span class="nc" id="L270">                        ackstate = QuorumPeer.ServerState.LOOKING;</span>
<span class="nc" id="L271">                        break;</span>
                    case 1:
<span class="nc" id="L273">                        ackstate = QuorumPeer.ServerState.LEADING;</span>
<span class="nc" id="L274">                        break;</span>
                    case 2:
<span class="nc" id="L276">                        ackstate = QuorumPeer.ServerState.FOLLOWING;</span>
                        break;
                    }

<span class="nc" id="L280">                    Vote current = self.getCurrentVote();</span>

<span class="nc bnc" id="L282" title="All 5 branches missed.">                    switch (type) {</span>
                    case 0:
                        // Receive challenge request
<span class="nc" id="L285">                        ToSend c = new ToSend(ToSend.mType.challenge, tag,</span>
<span class="nc" id="L286">                                current.getId(), current.getZxid(),</span>
<span class="nc" id="L287">                                logicalclock, self.getPeerState(),</span>
                                (InetSocketAddress) responsePacket
<span class="nc" id="L289">                                        .getSocketAddress());</span>
<span class="nc" id="L290">                        sendqueue.offer(c);</span>
<span class="nc" id="L291">                        break;</span>
                    case 1:
                        // Receive challenge and store somewhere else
<span class="nc" id="L294">                        long challenge = responseBuffer.getLong();</span>
<span class="nc" id="L295">                        saveChallenge(tag, challenge);</span>

<span class="nc" id="L297">                        break;</span>
                    case 2:
<span class="nc" id="L299">                        Notification n = new Notification();</span>
<span class="nc" id="L300">                        n.leader = responseBuffer.getLong();</span>
<span class="nc" id="L301">                        n.zxid = responseBuffer.getLong();</span>
<span class="nc" id="L302">                        n.epoch = responseBuffer.getLong();</span>
<span class="nc" id="L303">                        n.state = ackstate;</span>
<span class="nc" id="L304">                        n.addr = (InetSocketAddress) responsePacket</span>
<span class="nc" id="L305">                                .getSocketAddress();</span>

<span class="nc bnc" id="L307" title="All 8 branches missed.">                        if ((myMsg.lastEpoch &lt;= n.epoch)</span>
                                &amp;&amp; ((n.zxid &gt; myMsg.lastProposedZxid) 
                                || ((n.zxid == myMsg.lastProposedZxid) 
                                &amp;&amp; (n.leader &gt; myMsg.lastProposedLeader)))) {
<span class="nc" id="L311">                            myMsg.lastProposedZxid = n.zxid;</span>
<span class="nc" id="L312">                            myMsg.lastProposedLeader = n.leader;</span>
<span class="nc" id="L313">                            myMsg.lastEpoch = n.epoch;</span>
                        }

                        long recChallenge;
<span class="nc" id="L317">                        InetSocketAddress addr = (InetSocketAddress) responsePacket</span>
<span class="nc" id="L318">                                .getSocketAddress();</span>
<span class="nc bnc" id="L319" title="All 2 branches missed.">                        if (authEnabled) {</span>
<span class="nc" id="L320">                            ConcurrentHashMap&lt;Long, Long&gt; tmpMap = addrChallengeMap.get(addr);</span>
<span class="nc bnc" id="L321" title="All 2 branches missed.">                            if(tmpMap != null){</span>
<span class="nc bnc" id="L322" title="All 2 branches missed.">                                if (tmpMap.get(tag) != null) {</span>
<span class="nc" id="L323">                                    recChallenge = responseBuffer.getLong();</span>

<span class="nc bnc" id="L325" title="All 2 branches missed.">                                    if (tmpMap.get(tag) == recChallenge) {</span>
<span class="nc" id="L326">                                        recvqueue.offer(n);</span>

<span class="nc" id="L328">                                        ToSend a = new ToSend(ToSend.mType.ack,</span>
<span class="nc" id="L329">                                                tag, current.getId(),</span>
<span class="nc" id="L330">                                                current.getZxid(),</span>
<span class="nc" id="L331">                                                logicalclock, self.getPeerState(),</span>
                                                addr);

<span class="nc" id="L334">                                        sendqueue.offer(a);</span>
<span class="nc" id="L335">                                    } else {</span>
<span class="nc" id="L336">                                        LOG.warn(&quot;Incorrect challenge: &quot;</span>
                                                + recChallenge + &quot;, &quot;
<span class="nc" id="L338">                                                + addrChallengeMap.toString());</span>
                                    }
                                } else {
<span class="nc" id="L341">                                    LOG.warn(&quot;No challenge for host: &quot; + addr</span>
                                            + &quot; &quot; + tag);
                                }
                            }
<span class="nc" id="L345">                        } else {</span>
<span class="nc" id="L346">                            recvqueue.offer(n);</span>

<span class="nc" id="L348">                            ToSend a = new ToSend(ToSend.mType.ack, tag,</span>
<span class="nc" id="L349">                                    current.getId(), current.getZxid(),</span>
<span class="nc" id="L350">                                    logicalclock, self.getPeerState(),</span>
                                    (InetSocketAddress) responsePacket
<span class="nc" id="L352">                                            .getSocketAddress());</span>

<span class="nc" id="L354">                            sendqueue.offer(a);</span>
                        }
<span class="nc" id="L356">                        break;</span>

                    // Upon reception of an ack message, remove it from the
                    // queue
                    case 3:
<span class="nc" id="L361">                        Semaphore s = ackMutex.get(tag);</span>
                        
<span class="nc bnc" id="L363" title="All 2 branches missed.">                        if(s != null)</span>
<span class="nc" id="L364">                            s.release();</span>
<span class="nc" id="L365">                        else LOG.error(&quot;Empty ack semaphore&quot;);</span>
                        
<span class="nc" id="L367">                        ackset.add(tag);</span>

<span class="nc bnc" id="L369" title="All 2 branches missed.">                        if (authEnabled) {</span>
<span class="nc" id="L370">                            ConcurrentHashMap&lt;Long, Long&gt; tmpMap = addrChallengeMap.get(responsePacket</span>
<span class="nc" id="L371">                                    .getSocketAddress());</span>
<span class="nc bnc" id="L372" title="All 2 branches missed.">                            if(tmpMap != null) {</span>
<span class="nc" id="L373">                                tmpMap.remove(tag);</span>
                            } else {
<span class="nc" id="L375">                                LOG.warn(&quot;No such address in the ensemble configuration &quot; + responsePacket</span>
<span class="nc" id="L376">                                    .getSocketAddress());</span>
                            }
                        }

<span class="nc bnc" id="L380" title="All 2 branches missed.">                        if (ackstate != QuorumPeer.ServerState.LOOKING) {</span>
<span class="nc" id="L381">                            Notification outofsync = new Notification();</span>
<span class="nc" id="L382">                            outofsync.leader = responseBuffer.getLong();</span>
<span class="nc" id="L383">                            outofsync.zxid = responseBuffer.getLong();</span>
<span class="nc" id="L384">                            outofsync.epoch = responseBuffer.getLong();</span>
<span class="nc" id="L385">                            outofsync.state = ackstate;</span>
<span class="nc" id="L386">                            outofsync.addr = (InetSocketAddress) responsePacket</span>
<span class="nc" id="L387">                                    .getSocketAddress();</span>

<span class="nc" id="L389">                            recvqueue.offer(outofsync);</span>
<span class="nc" id="L390">                        }</span>

                        break;
                    // Default case
                    default:
<span class="nc" id="L395">                        LOG.warn(&quot;Received message of incorrect type &quot; + type);</span>
                        break;
                    }
<span class="nc" id="L398">                }</span>
            }
        }

        class WorkerSender implements Runnable {

            Random rand;
            int maxAttempts;
<span class="nc" id="L406">            int ackWait = finalizeWait;</span>

            /*
             * Receives a socket and max number of attempts as input
             */

<span class="nc" id="L412">            WorkerSender(int attempts) {</span>
<span class="nc" id="L413">                maxAttempts = attempts;</span>
<span class="nc" id="L414">                rand = new Random(java.lang.Thread.currentThread().getId()</span>
<span class="nc" id="L415">                        + System.currentTimeMillis());</span>
<span class="nc" id="L416">            }</span>

            long genChallenge() {
<span class="nc" id="L419">                byte buf[] = new byte[8];</span>

<span class="nc" id="L421">                buf[0] = (byte) ((challengeCounter &amp; 0xff000000) &gt;&gt;&gt; 24);</span>
<span class="nc" id="L422">                buf[1] = (byte) ((challengeCounter &amp; 0x00ff0000) &gt;&gt;&gt; 16);</span>
<span class="nc" id="L423">                buf[2] = (byte) ((challengeCounter &amp; 0x0000ff00) &gt;&gt;&gt; 8);</span>
<span class="nc" id="L424">                buf[3] = (byte) ((challengeCounter &amp; 0x000000ff));</span>

<span class="nc" id="L426">                challengeCounter++;</span>
<span class="nc" id="L427">                int secret = rand.nextInt(java.lang.Integer.MAX_VALUE);</span>

<span class="nc" id="L429">                buf[4] = (byte) ((secret &amp; 0xff000000) &gt;&gt;&gt; 24);</span>
<span class="nc" id="L430">                buf[5] = (byte) ((secret &amp; 0x00ff0000) &gt;&gt;&gt; 16);</span>
<span class="nc" id="L431">                buf[6] = (byte) ((secret &amp; 0x0000ff00) &gt;&gt;&gt; 8);</span>
<span class="nc" id="L432">                buf[7] = (byte) ((secret &amp; 0x000000ff));</span>

<span class="nc" id="L434">                return (((long)(buf[0] &amp; 0xFF)) &lt;&lt; 56)  </span>
                        + (((long)(buf[1] &amp; 0xFF)) &lt;&lt; 48)
                        + (((long)(buf[2] &amp; 0xFF)) &lt;&lt; 40) 
                        + (((long)(buf[3] &amp; 0xFF)) &lt;&lt; 32)
                        + (((long)(buf[4] &amp; 0xFF)) &lt;&lt; 24) 
                        + (((long)(buf[5] &amp; 0xFF)) &lt;&lt; 16)
                        + (((long)(buf[6] &amp; 0xFF)) &lt;&lt; 8) 
                        + ((long)(buf[7] &amp; 0xFF));
            }

            public void run() {
                while (true) {
                    try {
<span class="nc" id="L447">                        ToSend m = sendqueue.take();</span>
<span class="nc" id="L448">                        process(m);</span>
<span class="nc" id="L449">                    } catch (InterruptedException e) {</span>
<span class="nc" id="L450">                        break;</span>
<span class="nc" id="L451">                    }</span>

                }
<span class="nc" id="L454">            }</span>

            private void process(ToSend m) {
<span class="nc" id="L457">                int attempts = 0;</span>
                byte zeroes[];
<span class="nc" id="L459">                byte requestBytes[] = new byte[48];</span>
<span class="nc" id="L460">                DatagramPacket requestPacket = new DatagramPacket(requestBytes,</span>
                        requestBytes.length);
<span class="nc" id="L462">                ByteBuffer requestBuffer = ByteBuffer.wrap(requestBytes);</span>

<span class="nc bnc" id="L464" title="All 5 branches missed.">                switch (m.type) {</span>
                case 0:
                    /*
                     * Building challenge request packet to send
                     */
<span class="nc" id="L469">                    requestBuffer.clear();</span>
<span class="nc" id="L470">                    requestBuffer.putInt(ToSend.mType.crequest.ordinal());</span>
<span class="nc" id="L471">                    requestBuffer.putLong(m.tag);</span>
<span class="nc" id="L472">                    requestBuffer.putInt(m.state.ordinal());</span>
<span class="nc" id="L473">                    zeroes = new byte[32];</span>
<span class="nc" id="L474">                    requestBuffer.put(zeroes);</span>

<span class="nc" id="L476">                    requestPacket.setLength(48);</span>
                    try {
<span class="nc" id="L478">                        requestPacket.setSocketAddress(m.addr);</span>
<span class="nc" id="L479">                    } catch (IllegalArgumentException e) {</span>
                        // Sun doesn't include the address that causes this
                        // exception to be thrown, so we wrap the exception
                        // in order to capture this critical detail.
<span class="nc" id="L483">                        throw new IllegalArgumentException(</span>
                                &quot;Unable to set socket address on packet, msg:&quot;
<span class="nc" id="L485">                                + e.getMessage() + &quot; with addr:&quot; + m.addr,</span>
                                e);
<span class="nc" id="L487">                    }</span>

                    try {
<span class="nc bnc" id="L490" title="All 2 branches missed.">                        if (challengeMap.get(m.tag) == null) {</span>
<span class="nc" id="L491">                            mySocket.send(requestPacket);</span>
                        }
<span class="nc" id="L493">                    } catch (IOException e) {</span>
<span class="nc" id="L494">                        LOG.warn(&quot;Exception while sending challenge: &quot;, e);</span>
<span class="nc" id="L495">                    }</span>

<span class="nc" id="L497">                    break;</span>
                case 1:
                    /*
                     * Building challenge packet to send
                     */

                    long newChallenge;
<span class="nc" id="L504">                    ConcurrentHashMap&lt;Long, Long&gt; tmpMap = addrChallengeMap.get(m.addr); </span>
<span class="nc bnc" id="L505" title="All 2 branches missed.">                    if(tmpMap != null){</span>
<span class="nc" id="L506">                        Long tmpLong = tmpMap.get(m.tag);</span>
<span class="nc bnc" id="L507" title="All 2 branches missed.">                        if (tmpLong != null) {</span>
<span class="nc" id="L508">                            newChallenge = tmpLong;</span>
                        } else {
<span class="nc" id="L510">                            newChallenge = genChallenge();</span>
                        }

<span class="nc" id="L513">                        tmpMap.put(m.tag, newChallenge);</span>

<span class="nc" id="L515">                        requestBuffer.clear();</span>
<span class="nc" id="L516">                        requestBuffer.putInt(ToSend.mType.challenge.ordinal());</span>
<span class="nc" id="L517">                        requestBuffer.putLong(m.tag);</span>
<span class="nc" id="L518">                        requestBuffer.putInt(m.state.ordinal());</span>
<span class="nc" id="L519">                        requestBuffer.putLong(newChallenge);</span>
<span class="nc" id="L520">                        zeroes = new byte[24];</span>
<span class="nc" id="L521">                        requestBuffer.put(zeroes);</span>

<span class="nc" id="L523">                        requestPacket.setLength(48);</span>
                        try {
<span class="nc" id="L525">                            requestPacket.setSocketAddress(m.addr);</span>
<span class="nc" id="L526">                        } catch (IllegalArgumentException e) {</span>
                            // Sun doesn't include the address that causes this
                            // exception to be thrown, so we wrap the exception
                            // in order to capture this critical detail.
<span class="nc" id="L530">                            throw new IllegalArgumentException(</span>
                                    &quot;Unable to set socket address on packet, msg:&quot;
<span class="nc" id="L532">                                    + e.getMessage() + &quot; with addr:&quot; + m.addr,</span>
                                    e);
<span class="nc" id="L534">                        }</span>


                        try {
<span class="nc" id="L538">                            mySocket.send(requestPacket);</span>
<span class="nc" id="L539">                        } catch (IOException e) {</span>
<span class="nc" id="L540">                            LOG.warn(&quot;Exception while sending challenge: &quot;, e);</span>
<span class="nc" id="L541">                        }</span>
<span class="nc" id="L542">                    } else {</span>
<span class="nc" id="L543">                        LOG.error(&quot;Address is not in the configuration: &quot; + m.addr);</span>
                    }

<span class="nc" id="L546">                    break;</span>
                case 2:

                    /*
                     * Building notification packet to send
                     */

<span class="nc" id="L553">                    requestBuffer.clear();</span>
<span class="nc" id="L554">                    requestBuffer.putInt(m.type);</span>
<span class="nc" id="L555">                    requestBuffer.putLong(m.tag);</span>
<span class="nc" id="L556">                    requestBuffer.putInt(m.state.ordinal());</span>
<span class="nc" id="L557">                    requestBuffer.putLong(m.leader);</span>
<span class="nc" id="L558">                    requestBuffer.putLong(m.zxid);</span>
<span class="nc" id="L559">                    requestBuffer.putLong(m.epoch);</span>
<span class="nc" id="L560">                    zeroes = new byte[8];</span>
<span class="nc" id="L561">                    requestBuffer.put(zeroes);</span>

<span class="nc" id="L563">                    requestPacket.setLength(48);</span>
                    try {
<span class="nc" id="L565">                        requestPacket.setSocketAddress(m.addr);</span>
<span class="nc" id="L566">                    } catch (IllegalArgumentException e) {</span>
                        // Sun doesn't include the address that causes this
                        // exception to be thrown, so we wrap the exception
                        // in order to capture this critical detail.
<span class="nc" id="L570">                        throw new IllegalArgumentException(</span>
                                &quot;Unable to set socket address on packet, msg:&quot;
<span class="nc" id="L572">                                + e.getMessage() + &quot; with addr:&quot; + m.addr,</span>
                                e);
<span class="nc" id="L574">                    }</span>


<span class="nc" id="L577">                    boolean myChallenge = false;</span>
<span class="nc" id="L578">                    boolean myAck = false;</span>

<span class="nc bnc" id="L580" title="All 2 branches missed.">                    while (attempts &lt; maxAttempts) {</span>
                        try {
                            /*
                             * Try to obtain a challenge only if does not have
                             * one yet
                             */

<span class="nc bnc" id="L587" title="All 4 branches missed.">                            if (!myChallenge &amp;&amp; authEnabled) {</span>
<span class="nc" id="L588">                                ToSend crequest = new ToSend(</span>
                                        ToSend.mType.crequest, m.tag, m.leader,
                                        m.zxid, m.epoch,
                                        QuorumPeer.ServerState.LOOKING, m.addr);
<span class="nc" id="L592">                                sendqueue.offer(crequest);</span>

                                try {
<span class="nc" id="L595">                                    double timeout = ackWait</span>
<span class="nc" id="L596">                                            * java.lang.Math.pow(2, attempts);</span>

<span class="nc" id="L598">                                    Semaphore s = new Semaphore(0);</span>
<span class="nc" id="L599">                                    synchronized(Messenger.this) {</span>
<span class="nc" id="L600">                                        challengeMutex.put(m.tag, s);</span>
<span class="nc" id="L601">                                        s.tryAcquire((long) timeout, TimeUnit.MILLISECONDS);</span>
<span class="nc" id="L602">                                        myChallenge = challengeMap</span>
<span class="nc" id="L603">                                                .containsKey(m.tag);</span>
<span class="nc" id="L604">                                    }</span>
<span class="nc" id="L605">                                } catch (InterruptedException e) {</span>
<span class="nc" id="L606">                                    LOG.warn(&quot;Challenge request exception: &quot;, e);</span>
<span class="nc" id="L607">                                } </span>
                            }

                            /*
                             * If don't have challenge yet, skip sending
                             * notification
                             */

<span class="nc bnc" id="L615" title="All 4 branches missed.">                            if (authEnabled &amp;&amp; !myChallenge) {</span>
<span class="nc" id="L616">                                attempts++;</span>
<span class="nc" id="L617">                                continue;</span>
                            }

<span class="nc bnc" id="L620" title="All 2 branches missed.">                            if (authEnabled) {</span>
<span class="nc" id="L621">                                requestBuffer.position(40);</span>
<span class="nc" id="L622">                                Long tmpLong = challengeMap.get(m.tag);</span>
<span class="nc bnc" id="L623" title="All 2 branches missed.">                                if(tmpLong != null){</span>
<span class="nc" id="L624">                                    requestBuffer.putLong(tmpLong);</span>
                                } else {
<span class="nc" id="L626">                                    LOG.warn(&quot;No challenge with tag: &quot; + m.tag);</span>
                                }
                            }
<span class="nc" id="L629">                            mySocket.send(requestPacket);</span>
                            try {
<span class="nc" id="L631">                                Semaphore s = new Semaphore(0);</span>
<span class="nc" id="L632">                                double timeout = ackWait</span>
<span class="nc" id="L633">                                        * java.lang.Math.pow(10, attempts);</span>
<span class="nc" id="L634">                                ackMutex.put(m.tag, s);</span>
<span class="nc" id="L635">                                s.tryAcquire((int) timeout, TimeUnit.MILLISECONDS);</span>
<span class="nc" id="L636">                            } catch (InterruptedException e) {</span>
<span class="nc" id="L637">                                LOG.warn(&quot;Ack exception: &quot;, e);</span>
<span class="nc" id="L638">                            }</span>
                            
<span class="nc bnc" id="L640" title="All 2 branches missed.">                            if(ackset.remove(m.tag)){</span>
<span class="nc" id="L641">                                myAck = true;</span>
                            } 
                        
<span class="nc" id="L644">                        } catch (IOException e) {</span>
<span class="nc" id="L645">                            LOG.warn(&quot;Sending exception: &quot;, e);</span>
                            /*
                             * Do nothing, just try again
                             */
<span class="nc" id="L649">                        }</span>
<span class="nc bnc" id="L650" title="All 2 branches missed.">                        if (myAck) {</span>
                            /*
                             * Received ack successfully, so return
                             */
<span class="nc" id="L654">                            challengeMap.remove(m.tag);</span>
                            
<span class="nc" id="L656">                            return;</span>
                        } else
<span class="nc" id="L658">                            attempts++;</span>
                    }
                    /*
                     * Return message to queue for another attempt later if
                     * epoch hasn't changed.
                     */
<span class="nc bnc" id="L664" title="All 2 branches missed.">                    if (m.epoch == logicalclock) {</span>
<span class="nc" id="L665">                        challengeMap.remove(m.tag);</span>
<span class="nc" id="L666">                        sendqueue.offer(m);</span>
                    }
                    break;
                case 3:

<span class="nc" id="L671">                    requestBuffer.clear();</span>
<span class="nc" id="L672">                    requestBuffer.putInt(m.type);</span>
<span class="nc" id="L673">                    requestBuffer.putLong(m.tag);</span>
<span class="nc" id="L674">                    requestBuffer.putInt(m.state.ordinal());</span>
<span class="nc" id="L675">                    requestBuffer.putLong(m.leader);</span>
<span class="nc" id="L676">                    requestBuffer.putLong(m.zxid);</span>
<span class="nc" id="L677">                    requestBuffer.putLong(m.epoch);</span>

<span class="nc" id="L679">                    requestPacket.setLength(48);</span>
                    try {
<span class="nc" id="L681">                        requestPacket.setSocketAddress(m.addr);</span>
<span class="nc" id="L682">                    } catch (IllegalArgumentException e) {</span>
                        // Sun doesn't include the address that causes this
                        // exception to be thrown, so we wrap the exception
                        // in order to capture this critical detail.
<span class="nc" id="L686">                        throw new IllegalArgumentException(</span>
                                &quot;Unable to set socket address on packet, msg:&quot;
<span class="nc" id="L688">                                + e.getMessage() + &quot; with addr:&quot; + m.addr,</span>
                                e);
<span class="nc" id="L690">                    }</span>


                    try {
<span class="nc" id="L694">                        mySocket.send(requestPacket);</span>
<span class="nc" id="L695">                    } catch (IOException e) {</span>
<span class="nc" id="L696">                        LOG.warn(&quot;Exception while sending ack: &quot;, e);</span>
<span class="nc" id="L697">                    }</span>
                    break;
                }
<span class="nc" id="L700">            }</span>
        }

        public boolean queueEmpty() {
<span class="nc bnc" id="L704" title="All 4 branches missed.">            return (sendqueue.isEmpty() || ackset.isEmpty() || recvqueue</span>
<span class="nc bnc" id="L705" title="All 2 branches missed.">                    .isEmpty());</span>
        }

<span class="nc" id="L708">        Messenger(int threads, DatagramSocket s) {</span>
<span class="nc" id="L709">            mySocket = s;</span>
<span class="nc" id="L710">            ackset =  Collections.&lt;Long&gt;newSetFromMap(new ConcurrentHashMap&lt;Long, Boolean&gt;());</span>
<span class="nc" id="L711">            challengeMap = new ConcurrentHashMap&lt;Long, Long&gt;();</span>
<span class="nc" id="L712">            challengeMutex = new ConcurrentHashMap&lt;Long, Semaphore&gt;();</span>
<span class="nc" id="L713">            ackMutex = new ConcurrentHashMap&lt;Long, Semaphore&gt;();</span>
<span class="nc" id="L714">            addrChallengeMap = new ConcurrentHashMap&lt;InetSocketAddress, ConcurrentHashMap&lt;Long, Long&gt;&gt;();</span>
<span class="nc" id="L715">            lastProposedLeader = 0;</span>
<span class="nc" id="L716">            lastProposedZxid = 0;</span>
<span class="nc" id="L717">            lastEpoch = 0;</span>

<span class="nc bnc" id="L719" title="All 2 branches missed.">            for (int i = 0; i &lt; threads; ++i) {</span>
<span class="nc" id="L720">                Thread t = new ZooKeeperThread(new WorkerSender(3),</span>
                        &quot;WorkerSender Thread: &quot; + (i + 1));
<span class="nc" id="L722">                t.setDaemon(true);</span>
<span class="nc" id="L723">                t.start();</span>
            }

<span class="nc bnc" id="L726" title="All 2 branches missed.">            for (QuorumServer server : self.getVotingView().values()) {</span>
<span class="nc" id="L727">                InetSocketAddress saddr = new InetSocketAddress(server.addr</span>
<span class="nc" id="L728">                        .getAddress(), port);</span>
<span class="nc" id="L729">                addrChallengeMap.put(saddr, new ConcurrentHashMap&lt;Long, Long&gt;());</span>
<span class="nc" id="L730">            }</span>

<span class="nc" id="L732">            Thread t = new ZooKeeperThread(new WorkerReceiver(s, this),</span>
<span class="nc" id="L733">                    &quot;WorkerReceiver-&quot; + s.getRemoteSocketAddress());</span>
<span class="nc" id="L734">            t.start();</span>
<span class="nc" id="L735">        }</span>

    }

    QuorumPeer self;
    int port;
    volatile long logicalclock; /* Election instance */
    DatagramSocket mySocket;
    long proposedLeader;
    long proposedZxid;

    public AuthFastLeaderElection(QuorumPeer self,
<span class="nc" id="L747">            boolean auth) {</span>
<span class="nc" id="L748">        this.authEnabled = auth;</span>
<span class="nc" id="L749">        starter(self);</span>
<span class="nc" id="L750">    }</span>

<span class="nc" id="L752">    public AuthFastLeaderElection(QuorumPeer self) {</span>
<span class="nc" id="L753">        starter(self);</span>
<span class="nc" id="L754">    }</span>

    private void starter(QuorumPeer self) {
<span class="nc" id="L757">        this.self = self;</span>
<span class="nc" id="L758">        port = self.getVotingView().get(self.getId()).electionAddr.getPort();</span>
<span class="nc" id="L759">        proposedLeader = -1;</span>
<span class="nc" id="L760">        proposedZxid = -1;</span>

        try {
<span class="nc" id="L763">            mySocket = new DatagramSocket(port);</span>
            // mySocket.setSoTimeout(20000);
<span class="nc" id="L765">        } catch (SocketException e1) {</span>
<span class="nc" id="L766">            e1.printStackTrace();</span>
<span class="nc" id="L767">            throw new RuntimeException();</span>
<span class="nc" id="L768">        }</span>
<span class="nc" id="L769">        sendqueue = new LinkedBlockingQueue&lt;ToSend&gt;(2 * self.getVotingView().size());</span>
<span class="nc" id="L770">        recvqueue = new LinkedBlockingQueue&lt;Notification&gt;(2 * self.getVotingView()</span>
<span class="nc" id="L771">                .size());</span>
<span class="nc" id="L772">        new Messenger(self.getVotingView().size() * 2, mySocket);</span>
<span class="nc" id="L773">    }</span>

    private void leaveInstance() {
<span class="nc" id="L776">        logicalclock++;</span>
<span class="nc" id="L777">    }</span>

    private void sendNotifications() {
<span class="nc bnc" id="L780" title="All 2 branches missed.">        for (QuorumServer server : self.getView().values()) {</span>

<span class="nc" id="L782">            ToSend notmsg = new ToSend(ToSend.mType.notification,</span>
                    AuthFastLeaderElection.sequencer++, proposedLeader,
                    proposedZxid, logicalclock, QuorumPeer.ServerState.LOOKING,
<span class="nc" id="L785">                    self.getView().get(server.id).electionAddr);</span>

<span class="nc" id="L787">            sendqueue.offer(notmsg);</span>
<span class="nc" id="L788">        }</span>
<span class="nc" id="L789">    }</span>

    private boolean totalOrderPredicate(long id, long zxid) {
<span class="nc bnc" id="L792" title="All 6 branches missed.">        if ((zxid &gt; proposedZxid)</span>
                || ((zxid == proposedZxid) &amp;&amp; (id &gt; proposedLeader)))
<span class="nc" id="L794">            return true;</span>
        else
<span class="nc" id="L796">            return false;</span>

    }

    private boolean termPredicate(HashMap&lt;InetSocketAddress, Vote&gt; votes,
            long l, long zxid) {


<span class="nc" id="L804">        Collection&lt;Vote&gt; votesCast = votes.values();</span>
<span class="nc" id="L805">        int count = 0;</span>
        /*
         * First make the views consistent. Sometimes peers will have different
         * zxids for a server depending on timing.
         */
<span class="nc bnc" id="L810" title="All 2 branches missed.">        for (Vote v : votesCast) {</span>
<span class="nc bnc" id="L811" title="All 4 branches missed.">            if ((v.getId() == l) &amp;&amp; (v.getZxid() == zxid))</span>
<span class="nc" id="L812">                count++;</span>
<span class="nc" id="L813">        }</span>

<span class="nc bnc" id="L815" title="All 2 branches missed.">        if (count &gt; (self.getVotingView().size() / 2))</span>
<span class="nc" id="L816">            return true;</span>
        else
<span class="nc" id="L818">            return false;</span>

    }

    /**
     * There is nothing to shutdown in this implementation of
     * leader election, so we simply have an empty method.
     */
<span class="nc" id="L826">    public void shutdown(){}</span>
    
    /**
     * Invoked in QuorumPeer to find or elect a new leader.
     * 
     * @throws InterruptedException
     */
    public Vote lookForLeader() throws InterruptedException {
        try {
<span class="nc" id="L835">            self.jmxLeaderElectionBean = new LeaderElectionBean();</span>
<span class="nc" id="L836">            MBeanRegistry.getInstance().register(</span>
                    self.jmxLeaderElectionBean, self.jmxLocalPeerBean);        
<span class="nc" id="L838">        } catch (Exception e) {</span>
<span class="nc" id="L839">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="nc" id="L840">            self.jmxLeaderElectionBean = null;</span>
<span class="nc" id="L841">        }</span>

        try {
<span class="nc" id="L844">            HashMap&lt;InetSocketAddress, Vote&gt; recvset = </span>
                new HashMap&lt;InetSocketAddress, Vote&gt;();
    
<span class="nc" id="L847">            HashMap&lt;InetSocketAddress, Vote&gt; outofelection = </span>
                new HashMap&lt;InetSocketAddress, Vote&gt;();
    
<span class="nc" id="L850">            logicalclock++;</span>
    
<span class="nc" id="L852">            proposedLeader = self.getId();</span>
<span class="nc" id="L853">            proposedZxid = self.getLastLoggedZxid();</span>
    
<span class="nc" id="L855">            LOG.info(&quot;Election tally&quot;);</span>
<span class="nc" id="L856">            sendNotifications();</span>
    
            /*
             * Loop in which we exchange notifications until we find a leader
             */
    
<span class="nc bnc" id="L862" title="All 2 branches missed.">            while (self.getPeerState() == ServerState.LOOKING) {</span>
                /*
                 * Remove next notification from queue, times out after 2 times
                 * the termination time
                 */
<span class="nc" id="L867">                Notification n = recvqueue.poll(2 * finalizeWait,</span>
                        TimeUnit.MILLISECONDS);
    
                /*
                 * Sends more notifications if haven't received enough.
                 * Otherwise processes new notification.
                 */
<span class="nc bnc" id="L874" title="All 2 branches missed.">                if (n == null) {</span>
<span class="nc bnc" id="L875" title="All 4 branches missed.">                    if (((!outofelection.isEmpty()) || (recvset.size() &gt; 1)))</span>
<span class="nc" id="L876">                        sendNotifications();</span>
                } else
<span class="nc bnc" id="L878" title="All 4 branches missed.">                    switch (n.state) {</span>
                    case LOOKING:
<span class="nc bnc" id="L880" title="All 2 branches missed.">                        if (n.epoch &gt; logicalclock) {</span>
<span class="nc" id="L881">                            logicalclock = n.epoch;</span>
<span class="nc" id="L882">                            recvset.clear();</span>
<span class="nc bnc" id="L883" title="All 2 branches missed.">                            if (totalOrderPredicate(n.leader, n.zxid)) {</span>
<span class="nc" id="L884">                                proposedLeader = n.leader;</span>
<span class="nc" id="L885">                                proposedZxid = n.zxid;</span>
                            }
<span class="nc" id="L887">                            sendNotifications();</span>
<span class="nc bnc" id="L888" title="All 2 branches missed.">                        } else if (n.epoch &lt; logicalclock) {</span>
<span class="nc" id="L889">                            break;</span>
<span class="nc bnc" id="L890" title="All 2 branches missed.">                        } else if (totalOrderPredicate(n.leader, n.zxid)) {</span>
<span class="nc" id="L891">                            proposedLeader = n.leader;</span>
<span class="nc" id="L892">                            proposedZxid = n.zxid;</span>
    
<span class="nc" id="L894">                            sendNotifications();</span>
                        }
    
<span class="nc" id="L897">                        recvset.put(n.addr, new Vote(n.leader, n.zxid));</span>
    
                        // If have received from all nodes, then terminate
<span class="nc bnc" id="L900" title="All 2 branches missed.">                        if (self.getVotingView().size() == recvset.size()) {</span>
<span class="nc bnc" id="L901" title="All 2 branches missed.">                            self.setPeerState((proposedLeader == self.getId()) ? </span>
                                    ServerState.LEADING: ServerState.FOLLOWING);
                            // if (self.state == ServerState.FOLLOWING) {
                            // Thread.sleep(100);
                            // }
<span class="nc" id="L906">                            leaveInstance();</span>
<span class="nc" id="L907">                            return new Vote(proposedLeader, proposedZxid);</span>
    
<span class="nc bnc" id="L909" title="All 2 branches missed.">                        } else if (termPredicate(recvset, proposedLeader,</span>
                                proposedZxid)) {
                            // Otherwise, wait for a fixed amount of time
<span class="nc" id="L912">                            LOG.info(&quot;Passed predicate&quot;);</span>
<span class="nc" id="L913">                            Thread.sleep(finalizeWait);</span>
    
                            // Notification probe = recvqueue.peek();
    
                            // Verify if there is any change in the proposed leader
<span class="nc bnc" id="L918" title="All 2 branches missed.">                            while ((!recvqueue.isEmpty())</span>
<span class="nc bnc" id="L919" title="All 2 branches missed.">                                    &amp;&amp; !totalOrderPredicate(</span>
<span class="nc" id="L920">                                            recvqueue.peek().leader, recvqueue</span>
<span class="nc" id="L921">                                                    .peek().zxid)) {</span>
<span class="nc" id="L922">                                recvqueue.poll();</span>
                            }
<span class="nc bnc" id="L924" title="All 2 branches missed.">                            if (recvqueue.isEmpty()) {</span>
                                // LOG.warn(&quot;Proposed leader: &quot; +
                                // proposedLeader);
<span class="nc" id="L927">                                self.setPeerState(</span>
<span class="nc bnc" id="L928" title="All 2 branches missed.">                                        (proposedLeader == self.getId()) ? </span>
                                         ServerState.LEADING :
                                         ServerState.FOLLOWING);
    
<span class="nc" id="L932">                                leaveInstance();</span>
<span class="nc" id="L933">                                return new Vote(proposedLeader, proposedZxid);</span>
                            }
                        }
                        break;
                    case LEADING:
<span class="nc" id="L938">                        outofelection.put(n.addr, new Vote(n.leader, n.zxid));</span>
    
<span class="nc bnc" id="L940" title="All 2 branches missed.">                        if (termPredicate(outofelection, n.leader, n.zxid)) {</span>
    
<span class="nc bnc" id="L942" title="All 2 branches missed.">                            self.setPeerState((n.leader == self.getId()) ? </span>
                                    ServerState.LEADING: ServerState.FOLLOWING);
    
<span class="nc" id="L945">                            leaveInstance();</span>
<span class="nc" id="L946">                            return new Vote(n.leader, n.zxid);</span>
                        }
                        break;
                    case FOLLOWING:
<span class="nc" id="L950">                        outofelection.put(n.addr, new Vote(n.leader, n.zxid));</span>
    
<span class="nc bnc" id="L952" title="All 2 branches missed.">                        if (termPredicate(outofelection, n.leader, n.zxid)) {</span>
    
<span class="nc bnc" id="L954" title="All 2 branches missed.">                            self.setPeerState((n.leader == self.getId()) ? </span>
                                    ServerState.LEADING: ServerState.FOLLOWING);
    
<span class="nc" id="L957">                            leaveInstance();</span>
<span class="nc" id="L958">                            return new Vote(n.leader, n.zxid);</span>
                        }
                        break;
                    default:
                        break;
                    }
<span class="nc" id="L964">            }</span>
    
<span class="nc" id="L966">            return null;</span>
        } finally {
<span class="nc" id="L968">            try {</span>
<span class="nc bnc" id="L969" title="All 12 branches missed.">                if(self.jmxLeaderElectionBean != null){</span>
<span class="nc" id="L970">                    MBeanRegistry.getInstance().unregister(</span>
                            self.jmxLeaderElectionBean);
                }
<span class="nc" id="L973">            } catch (Exception e) {</span>
<span class="nc" id="L974">                LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="nc" id="L975">            }</span>
<span class="nc" id="L976">            self.jmxLeaderElectionBean = null;</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>